//////////////////////////////////////////////////////////////////////////////////
//
// File			: server.h
//
// Author		: Tom Stachowiak
//
// Date			: 3/19/98
//
// Description	: Server class header for the CPS project
//
//////////////////////////////////////////////////////////////////////////////////

#define IDLE 11
#define BUSY 12
#define MAX_MSG_SIZE 100
#define PLAY 111
#define SERVER_PORT 23879

class Server
{
	private:
		int port;
		int mainSocket;
		int state;
		FILE *log;
		FILE *dataFile;
		char *buffer;
		int size;

		int sendData(struct sockaddr_in *addr);
		void handleMessage(char *msg, int len, struct sockaddr_in *addr);
		int process(char *filename, int len, struct sockaddr_in *addr);

	public:
		int init(int prt, int len);
		void close();
		void run();
};
