//
// File				: conference.h
//
//////////////////////////////////////////////////////////////////////
#include "NCSmanagerDlg.h"

#define PLUGINS_CFG_PATH "PLUGINS.CFG"
#define DAEMON_PATH "Core\\BVengine.exe"


typedef struct _plugin
{
	int port;
	char name[50];
	char path[100];
	int started;
	PROCESS_INFORMATION info;
} PLUGIN; 

int start_conference(CNCSmanagerDlg *dlg);
void exit_conference(void);
void add_member(char *user, char *host);
void add_user(char *member);
void read_plugins(void);
void quit_plugins(void);
void startProcess(char *path, PROCESS_INFORMATION *pinfo);
void create_app(int port);
int app_started(int index);
void start_local_app(int index);
void quit_application(int port);
void quit_local_app(int index);
void info_app(int index);
void accept(void);
void reject(void);
void conf_reset(void);
void confAddMemberDlg();

// Archive
void confArchivePlay();
void confArchivePlayStop();
void confArchiveRec();
void confArchiveRecStop();

// NCS callbacks
void new_member(void *data);
void left_member(void *data);
void invited(void *data);
void start_app(void *data);
void server_users(void *data);
void timeout(void *data);
void connected(void *data);
void accepted(void *data);
void rejected(void *data);

// reading thread
DWORD readingThread(LPDWORD data);

// ringing
void startRing();
void stopRing();
DWORD ringingThread(LPDWORD data);

void getStartPath(char *path);
