///////////////////////////////////////////////////////////////////////////
// 
// File						: display.h
//
// Description				: Video display functions implementation
//
// Author					: Tomasz Stachowiak
//
// Date						: 11-21-96
//
////////////////////////////////////////////////////////////////////////////
#include <vfw.h>
#include "DisplayDlg.h"

#define QCIF_YUV_SIZE 38016
#define QCIF_LUM_SIZE 25344
#define QCIF_CR_SIZE 6336
#define QCIF_WIDTH 176
#define QCIF_HEIGHT 144

#define CREATE_DISPLAY 15864
#define DESTROY_DISPLAY 15866

typedef struct _display_data
{
	DisplayDlg *dpy;
	CClientDC *cDc;
	HDRAWDIB hDraw;
	HDC hDc;
	int first;
	int wndActive;
} DisplayData;

void displayInit(void);
DisplayDlg *displayOpen(DWORD user);
void displayYUV(unsigned char *data, int len, DWORD user);
void displayYUV9(unsigned char *data, int len, DWORD user);
void displayH261(void *data, int len, DWORD user);
void displayH263(void *data, int len, DWORD user);
void displayClose(DWORD user);
void displayQuit(void);
