// TSaudioDlg.cpp : implementation file
//

#include "stdafx.h"
#include <mmsystem.h>
#include "TSaudio.h"
#include "StatDlg.h"
#include "TSaudioDlg.h"
#include "TSaudioProc.h"
#include "Conference.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

Conference *audioConf;

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	afx_msg void OnTimer(UINT nIDEvent);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()



/////////////////////////////////////////////////////////////////////////////
// CTSaudioDlg dialog

CTSaudioDlg::CTSaudioDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTSaudioDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTSaudioDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_hMic = LoadBitmap(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDB_MIC));
	m_hNotMic = LoadBitmap(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDB_SPEAKER));
}

void CTSaudioDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTSaudioDlg)
	DDX_Control(pDX, IDC_PCM, m_PCM);
	DDX_Control(pDX, IDC_AUTO, m_Auto);
	DDX_Control(pDX, IDC_TALK, m_Talk);
	DDX_Control(pDX, IDC_TRESHOLD, m_treshold);
	DDX_Control(pDX, IDC_GSM, m_GSM);
	DDX_Control(pDX, IDC_ADPCM, m_ADPCM);
	DDX_Control(pDX, IDC_LED_OUT, m_LedOut);
	DDX_Control(pDX, IDC_LED_IN, m_LedIn);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTSaudioDlg, CDialog)
	//{{AFX_MSG_MAP(CTSaudioDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_ADPCM, OnAdpcm)
	ON_BN_CLICKED(IDC_GSM, OnGsm)
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDC_AUTO, OnAuto)
	ON_BN_CLICKED(IDC_TALK, OnTalk)
	ON_COMMAND(IDM_PANEL, OnPanel)
	ON_COMMAND(IDM_STAT, OnStat)
	ON_COMMAND(IDM_EXIT, OnExit)
	ON_BN_CLICKED(IDC_PCM, OnPcm)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTSaudioDlg message handlers

BOOL CTSaudioDlg::OnInitDialog()
{

	CDialog::OnInitDialog();

	
	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	CString strAboutMenu;
	strAboutMenu.LoadString(IDS_ABOUTBOX);
	if (!strAboutMenu.IsEmpty())
	{
		pSysMenu->AppendMenu(MF_SEPARATOR);
		pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
	}
	

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	m_ADPCM.SetCheck(1);
	m_GSM.SetCheck(0);
	m_Talk.SetCheck(1);
	m_Talk.SetBitmap(m_hMic);
	m_Auto.SetCheck(1);
	m_treshold.SetRange(0, 100);
	m_treshold.SetPos(2000/328);
	audioConf = new Conference(this);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTSaudioDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTSaudioDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTSaudioDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


void CTSaudioDlg::OnAdpcm() 
{
	m_ADPCM.SetCheck(1);
	m_GSM.SetCheck(0);
	m_PCM.SetCheck(0);
	audioConf->codeADPCM();
}

void CTSaudioDlg::OnGsm() 
{
	m_ADPCM.SetCheck(0);
	m_GSM.SetCheck(1);	
	m_PCM.SetCheck(0);
	audioConf->codeGSM();
}

void CTSaudioDlg::OnPcm() 
{
	m_ADPCM.SetCheck(0);
	m_GSM.SetCheck(0);	
	m_PCM.SetCheck(1);
	audioConf->codePCM();	
}

void CTSaudioDlg::OnClose() 
{
	delete audioConf;
	
	CDialog::OnClose();
}

void CTSaudioDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	if(nSBCode == TB_THUMBPOSITION)
	{
		audioConf->setTreshold(nPos);
	}
	
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CTSaudioDlg::OnAuto() 
{
	audioConf->setAuto(m_Auto.GetCheck());	
}

void CTSaudioDlg::OnTalk() 
{
	if(m_Talk.GetCheck())
		m_Talk.SetBitmap(m_hMic);
	else
		m_Talk.SetBitmap(m_hNotMic);

	audioConf->setTalk(m_Talk.GetCheck());
}

void CTSaudioDlg::OnPanel() 
{
	/*
	HMIXER mix;

	if(mixerOpen(&mix, 0, (unsigned long)m_hWnd, 0, CALLBACK_WINDOW | MIXER_OBJECTF_WAVEIN) != MMSYSERR_NOERROR)
		MessageBox("Mixer opening error");
		*/

	int len;
	char path[100];
	char name[20] = "windir";
	char winpath[100];

	len = GetEnvironmentVariable(name, winpath, 80);
	strcpy(path, winpath);
	strcat(path, "\\sndvol32.exe");
	if(!startProcess(path))
	{
		strcpy(path, winpath);
		strcat(path, "\\system32\\sndvol32.exe");
		startProcess(path);
	}
}

void CTSaudioDlg::OnStat() 
{
	// TODO: Add your command handler code here
	statdlg = new CStatDlg(audioConf, this);
	statdlg->Create(IDD_STATDLG, this);
	statdlg->ShowWindow(SW_SHOWNORMAL);
}

void CAboutDlg::OnTimer(UINT nIDEvent) 
{
	MessageBox("Timer");
	
	CDialog::OnTimer(nIDEvent);
}

void CTSaudioDlg::disableControl(void)
{
	//m_Talk.EnableWindow(FALSE);
	//m_Auto.EnableWindow(FALSE);
}

BOOL CTSaudioDlg::startProcess(char *path)
{
	STARTUPINFO sinfo;

	sinfo.cb = sizeof(STARTUPINFO);
	sinfo.lpReserved = NULL;
	sinfo.lpDesktop = NULL;
	sinfo.lpTitle = NULL;
	sinfo.dwFlags = STARTF_FORCEONFEEDBACK;
	sinfo.cbReserved2 = 0;
	sinfo.lpReserved2 = NULL;

	if(CreateProcess(path, NULL, NULL, NULL, FALSE, 
					NORMAL_PRIORITY_CLASS | DETACHED_PROCESS, NULL, NULL, 
					&sinfo, &pinfo)
		== FALSE)
		return FALSE;
		//MessageBox("Create process error");

	return TRUE;
}

void CTSaudioDlg::OnExit() 
{
	delete audioConf;	
	CDialog::EndDialog(0);
}

void CTSaudioDlg::autoTalk()
{
	m_Talk.SetCheck(1);
	m_Talk.SetBitmap(m_hMic);
}

void CTSaudioDlg::autoNotTalk()
{
	m_Talk.SetCheck(0);
	m_Talk.SetBitmap(m_hNotMic);
}

