#include <MMSYSTEM.H>
#include "Conference.h"

#define PORTION_SIZE 2*AUDIO_CHUNKS_NO*BASIC_AUDIO_SIZE
#define PORTION_SAMPLES AUDIO_CHUNKS_NO*BASIC_AUDIO_SIZE

typedef struct _audioOutPort
{
	HWAVEOUT handle;				// handle for out port
	HANDLE hEvent;					// event for synchronize writting(not used)
	WAVEHDR header[2];				// wave data header
	int headerNo;					// number of current header
	int first;						// writing state
	int active;
} AudioOutPort;


int audioInit(Conference *conf);
void audioClose(void);
short audioGetLevel(char *buffer);
    
/////////////////////////////////////////////////////////////////////////
// audio reading functions
int audioReadInit(void);
DWORD audioReadThread(LPDWORD lpdwParam);
void audioReadClose(void);
void audioReadChunk(void);
void audioReadHandler(void *buffer);
void audioReadStart(void);
void audioReadStop(void);

/////////////////////////////////////////////////////////////////////////
// audio writing functions
int audioWriteInit(void);
void audioWriteClose(void);
void audioWriteVolume(UINT vol);
void audioWriteChunk(void *buffer);
