#include "stdafx.h"
#include "rtp.h"
#include "UserData.h"

UserData::UserData(RTPheader *hdr)
{
	frames_received = 0;
	frames_lost = 0;
	frames_late = 0;
	last_ts = GetTickCount();
	last_seq = hdr->seq;
}

int UserData::frame(RTPheader *hdr)
{
	int tmp;
	int ok = 1;

	frames_received++;
	if(frames_received == 1)
	{
		last_ts = GetTickCount();
		last_seq = hdr->seq;
	}
	else
	{
		if(hdr->seq < last_seq)
		{
			frames_lost++;
			ok = 0;
		}

		tmp = GetTickCount();
		if(tmp > last_ts + 105)
			frames_late++;
		last_ts = tmp;
	}

	return ok;
}

int UserData::getPercentLost()
{
	if(frames_received == 0)
		return 0;

	return frames_lost*100/frames_received;
}

int UserData::getPercentLate()
{
	if(frames_received == 0)
		return 0;

	return frames_late*100/frames_received;
}

void UserData::reset()
{
	frames_received = 0;
	frames_lost = 0;
	frames_late = 0;
}
