// AudioOptDlg.cpp : implementation file
//

#include "stdafx.h"
#include "BuenaVista.h"
#include "AudioOptDlg.h"
#include "options.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAudioOptDlg dialog


CAudioOptDlg::CAudioOptDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAudioOptDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAudioOptDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CAudioOptDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAudioOptDlg)
	DDX_Control(pDX, IDC_VOLUME, m_Volume);
	DDX_Control(pDX, IDC_MUTE, m_Mute);
	DDX_Control(pDX, IDC_MICOFF, m_MicOff);
	DDX_Control(pDX, IDC_MICGAIN, m_MicGain);
	DDX_Control(pDX, IDC_COMPRESSION, m_Compression);
	DDX_Control(pDX, IDC_MODE, m_Mode);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAudioOptDlg, CDialog)
	//{{AFX_MSG_MAP(CAudioOptDlg)
	ON_BN_CLICKED(IDC_MICOFF, OnMicoff)
	ON_BN_CLICKED(IDC_MUTE, OnMute)
	ON_WM_HSCROLL()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAudioOptDlg message handlers

void CAudioOptDlg::OnMicoff() 
{
	// TODO: Add your control notification handler code here
	
}

void CAudioOptDlg::OnMute() 
{
	// TODO: Add your control notification handler code here
	
}

void CAudioOptDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// TODO: Add your message handler code here and/or call default
	
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

BOOL CAudioOptDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	m_Compression.AddString("GSM");
	m_Compression.AddString("ADPCM");
	m_Compression.AddString("PCM");
	m_Compression.SetCurSel(0);
	//m_Compression.SelectString(-1, c);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CAudioOptDlg::SetOptions(Options *opt)
{
	options = opt;

	switch(options->audio.compression)
	{
	case GSM:
		m_Compression.SetCurSel(0);
		break;

	case ADPCM:
		m_Compression.SetCurSel(1);
		break;

	case PCM:
		m_Compression.SetCurSel(2);
		break;

	}
	
	m_Mode.SetSel(0, -1);
	if(options->audio.mode == HALF_DUPLEX)
		m_Mode.ReplaceSel("Half Duplex");
	else
		m_Mode.ReplaceSel("Full Duplex");

	m_Mute.SetCheck(options->audio.mute);
	m_MicOff.SetCheck(options->audio.micOff);

	m_Volume.SetPos(options->audio.volume);
	m_MicGain.SetPos(options->audio.micGain);
}
