// OptionDlg.cpp : implementation file
//

#include "stdafx.h"
#include "BuenaVista.h"
#include "BuenaVistaDlg.h"
#include "OptionDlg.h"
#include "ConnDlg.h"
#include "AudioOptDlg.h"
#include "VideoOpt.h"
#include "Video.h"
#include "capture.h"
#include "options.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COptionDlg dialog


COptionDlg::COptionDlg(CBuenaVistaDlg *dlg, Options *opt, CWnd* pParent /*=NULL*/)
	: CDialog(COptionDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(COptionDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	
	options = opt;
	main_dlg = dlg;
}


void COptionDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COptionDlg)
	DDX_Control(pDX, IDC_OPTIONS_TAB, m_OptionTab);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(COptionDlg, CDialog)
	//{{AFX_MSG_MAP(COptionDlg)
	ON_NOTIFY(TCN_SELCHANGE, IDC_OPTIONS_TAB, OnSelchangeOptionsTab)
	ON_BN_CLICKED(IDC_APPLY, OnApply)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COptionDlg message handlers

BOOL COptionDlg::OnInitDialog() 
{
	RECT rect;

	CDialog::OnInitDialog();
	
	TC_ITEM TabCtrlItem;
	TabCtrlItem.mask = TCIF_TEXT;
    TabCtrlItem.pszText = "General";
	m_OptionTab.InsertItem( 0, &TabCtrlItem );
    TabCtrlItem.pszText = "Audio";
	m_OptionTab.InsertItem( 1, &TabCtrlItem );
    TabCtrlItem.pszText = "Video";
	m_OptionTab.InsertItem( 2, &TabCtrlItem );
	
	conndlg = new CConnDlg(&m_OptionTab);
	conndlg->Create(IDD_CONN_DLG, &m_OptionTab);
	((CConnDlg *)conndlg)->SetOptions(options);
	conndlg->GetClientRect(&rect);
	conndlg->MoveWindow(5, 25, rect.right, rect.bottom);

	audiodlg = new CAudioOptDlg(&m_OptionTab);
	audiodlg->Create(IDD_AUDIO_DLG, &m_OptionTab);
	((CAudioOptDlg *)audiodlg)->SetOptions(options);
	audiodlg->GetClientRect(&rect);
	audiodlg->MoveWindow(5, 25, rect.right, rect.bottom);

	videodlg = new CVideoOpt(&m_OptionTab);
	videodlg->Create(IDD_VIDEO_DLG, &m_OptionTab);
	((CVideoOpt *)videodlg)->SetOptions(options, (Video *)main_dlg->video);
	videodlg->GetClientRect(&rect);
	videodlg->MoveWindow(5, 25, rect.right, rect.bottom);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void COptionDlg::OnSelchangeOptionsTab(NMHDR* pNMHDR, LRESULT* pResult) 
{
	int nOption = m_OptionTab.GetCurSel();

	switch(nOption)
	{
	case 0:
		conndlg->ShowWindow(SW_SHOW);
		audiodlg->ShowWindow(SW_HIDE);
		videodlg->ShowWindow(SW_HIDE);
		break;
	case 1:
		conndlg->ShowWindow(SW_HIDE);
		audiodlg->ShowWindow(SW_SHOW);
		videodlg->ShowWindow(SW_HIDE);
		break;
	case 2:
		conndlg->ShowWindow(SW_HIDE);
		audiodlg->ShowWindow(SW_HIDE);
		videodlg->ShowWindow(SW_SHOW);
		break;
	}
	
	*pResult = 0;
}

void COptionDlg::OnApply() 
{
	int sel;

	sel = ((CVideoOpt *)videodlg)->m_CaptDev.GetCurSel();
	if(sel != 0)
	{
		//captureReconnect(sel);
	}

	sel = ((CConnDlg *)conndlg)->m_Connection.GetCurSel();
	((CConnDlg *)conndlg)->m_Connection.GetLBText(sel, options->connection);
	((CConnDlg *)conndlg)->m_Name.GetWindowText(options->user_name, 30);
	((CConnDlg *)conndlg)->m_Email.GetWindowText(options->user_email, 30);
	((CConnDlg *)conndlg)->m_Server.GetWindowText(options->server_name, 50);
	options->autoAccept = ((CConnDlg *)conndlg)->m_AutoAck.GetCheck();

	options->video.recOff = ((CVideoOpt *)videodlg)->m_RecOff.GetCheck();

	options->audio.mute = ((CAudioOptDlg *)audiodlg)->m_Mute.GetCheck();
	options->audio.micOff = ((CAudioOptDlg *)audiodlg)->m_MicOff.GetCheck();
	options->audio.volume = ((CAudioOptDlg *)audiodlg)->m_Volume.GetPos();
	options->audio.micGain = ((CAudioOptDlg *)audiodlg)->m_MicGain.GetPos();

	SetConnection(options->connection);
}

void COptionDlg::OnOK() 
{
	int sel;

	sel = ((CVideoOpt *)videodlg)->m_CaptDev.GetCurSel();
	options->video.device = sel;

	sel = ((CConnDlg *)conndlg)->m_Connection.GetCurSel();
	((CConnDlg *)conndlg)->m_Connection.GetLBText(sel, options->connection);
	((CConnDlg *)conndlg)->m_Name.GetWindowText(options->user_name, 30);
	((CConnDlg *)conndlg)->m_Email.GetWindowText(options->user_email, 30);
	((CConnDlg *)conndlg)->m_Server.GetWindowText(options->server_name, 50);
	options->autoAccept = ((CConnDlg *)conndlg)->m_AutoAck.GetCheck();

	SetConnection(options->connection);

	options->video.recOff = ((CVideoOpt *)videodlg)->m_RecOff.GetCheck();
	if(((CVideoOpt *)videodlg)->m_Fpssld.GetPos() < options->video.maxlimit)
		options->video.limit = ((CVideoOpt *)videodlg)->m_Fpssld.GetPos();
	else
		options->video.limit = options->video.maxlimit;
	//((Video *)main_dlg->video)->UpdateRate();


	options->audio.mute = ((CAudioOptDlg *)audiodlg)->m_Mute.GetCheck();
	options->audio.micOff = ((CAudioOptDlg *)audiodlg)->m_MicOff.GetCheck();
	options->audio.volume = ((CAudioOptDlg *)audiodlg)->m_Volume.GetPos();
	options->audio.micGain = ((CAudioOptDlg *)audiodlg)->m_MicGain.GetPos();

	conndlg->EndDialog(0);
	audiodlg->EndDialog(0);
	videodlg->EndDialog(0);
	
	CDialog::OnOK();
}

void COptionDlg::SetConnection(char *conn)
{
	if(strcmp(conn, "Modem 28.8") == 0)
	{
		options->video.compression = H263;
		options->video.limit = 4;
		options->video.maxlimit = 4;
		options->audio.compression = GSM;
	}

	if(strcmp(conn, "ISDN-1") == 0)
	{
		options->video.compression = H261;
		options->video.intraMode = FALSE;
		options->video.limit = 5;
		options->video.maxlimit = 5;
		options->audio.compression = ADPCM;
	}

	if(strcmp(conn, "ISDN-2") == 0)
	{
		options->video.compression = H261;
		options->video.intraMode = FALSE;
		options->video.limit = 10;
		options->video.maxlimit = 10;
		options->audio.compression = ADPCM;
	}

	if(strcmp(conn, "LAN") == 0)
	{
		options->video.compression = YUV9;
		options->video.limit = 10;
		options->video.maxlimit = 10;
		options->audio.compression = PCM;
	}

}
