/*************************************************************
Copyright (C) 1990, 1991, 1993 Andy C. Hung, all rights reserved.
PUBLIC DOMAIN LICENSE: Stanford University Portable Video Research
Group. If you use this software, you agree to the following: This
program package is purely experimental, and is licensed "as is".
Permission is granted to use, modify, and distribute this program
without charge for any purpose, provided this license/ disclaimer
notice appears in the copies.  No warranty or maintenance is given,
either expressed or implied.  In no event shall the author(s) be
liable to you or a third party for any special, incidental,
consequential, or other damages, arising out of the use or inability
to use the program for any purpose (or the loss of data), even if we
have been advised of such possibilities.  Any public reference or
advertisement of this source code should refer to it as the Portable
Video Research Group (PVRG) code, and not by any author(s) (or
Stanford University) name.
*************************************************************/
/*
************************************************************
prototypes.h

This file contains the functional prototypes for type checking.

************************************************************
*/


/* p64.c */
extern "C" {

extern void p64EncodeSequence();
extern void p64DecodeSequence();
extern void PrintImage();
extern void PrintFrame();
extern void MakeImage();
extern void MakeFrame();
extern void MakeFstore();
extern void MakeStat();
extern void MakeRate();
extern void SetCCITT();
extern void Help();
extern void MakeFileNames();
extern void VerifyFiles();

/* codec.c */

void EncodeAC(int index, int *matrix);
void CBPEncodeAC(int index, int *matrix);
void DecodeAC(int index,int *matrix);
void CBPDecodeAC(int index,int *matrix);
int DecodeDC();
void EncodeDC(int coef);

/* huffman.c */

extern void inithuff();
int Encode(int val, EHUFF *huff);
int Decode(DHUFF *huff);
void PrintDhuff(DHUFF *huff);
void PrintEhuff(EHUFF *huff);
void PrintTable(int *table);

/* io.c */

void MakeIob(int flag);
extern void GlobalMC();
void SubOverlay(int *matrix);
void AddOverlay(int *matrix);
void SubCompensate(int *matrix);
void AddCompensate(int *matrix);
void HalfSubCompensate(int *matrix);
void HalfAddCompensate(int *matrix);
void LoadFilterMatrix(unsigned char *memloc, int *output);
void SubFCompensate(int *matrix);
void AddFCompensate(int *matrix);
void HalfSubFCompensate(int *matrix);
void HalfAddFCompensate(int *matrix);
extern void ClearIob();
void CopyIob2FS(FSTORE *fs);
void ClearFS(FSTORE *fs);
int ParityFS(FSTORE *fs);
void InitFS(FSTORE *fs);
extern void ReadIob();
void InstallIob(int index);
void InstallFS(int index, FSTORE *fs);
extern void WriteIob();
void MoveTo(int g,int m,int h,int v);
extern int Bpos(int g, int m, int h, int v);
void ReadBlock(int *store);
void WriteBlock(int *store);
extern void PrintIob();

/* chendct.c */

void ChenDct(int *x, int *y);
void ChenIDct(int *x, int *y);

/* lexer.c */

//extern void initparser();
//extern void parser();

/* marker.c */

extern void WritePictureHeader();
extern void ReadPictureHeader();
extern void WriteGOBHeader();
extern int ReadHeaderHeader();
extern void ReadHeaderTrailer();
extern void ReadGOBHeader();
extern void WriteMBHeader();
extern int ReadMBHeader();

/* me.c */

extern void initmc();
extern void FastBME();
void BruteMotionEstimation(MEM *pmem, MEM *fmem);
extern void BMC();
extern MEM *MotionCompensation();

/* mem.c */
BLOCK MakeBlock();
void CopyBlock(BLOCK b1, BLOCK b2);
void CopyMem(MEM *m1, MEM *m2);
ClearMem(MEM *m1);
int ParityMem(MEM *mem);
void SetPointerBlock(int px, int py, MEM *mem, BLOCK block);
MEM *MakeMem(int width, int height);
void FreeMem(MEM *mem);
MEM *LoadMem(char *filename, int width, int height, MEM *omem);
MEM *SaveMem(char *filename, MEM *mem);

/* stat.c */

extern void Statistics();

/* stream.c */

void mropen(char *filename);
void mwopen(char *filename);
void mputv(int n,int b);
int mgetv(int n);
void mwseek(long distance);
void mrseek(long distance);
extern void mrclose();
extern void mwclose();
extern int mgetb();
extern long mwtell();
extern long mrtell();
extern int seof();

/* transform.c */
void ReferenceDct(int *matrix, int *newmatrix);
void ReferenceIDct(int *matrix, int *newmatrix);
void TransposeMatrix(int *matrix, int *newmatrix);
void CCITTQuantize(int *matrix, int dcqfact, int acqfact);
void CCITTFlatQuantize(int *matrix, int dcqfact, int acqfact);
void ICCITTFlatQuantize(int *matrix, int dcqfact, int acqfact);
void ICCITTQuantize(int *matrix, int dcqfact, int acqfact);
void BoundDctMatrix(int *matrix);
void BoundIDctMatrix(int *matrix);
void FlatBoundQuantizeMatrix(int *matrix);
void BoundQuantizeMatrix(int *matrix);
void IZigzagMatrix(int *imatrix, int *omatrix);
void ZigzagMatrix(int *imatrix, int *omatrix);
void PrintMatrix(int *matrix);
void ClearMatrix(int *matrix);
}