// ActiveUsersDialog.cpp : implementation file
//

#include "stdafx.h"
#include "DSProxy.h"
#include "DSProxyExport.h"
#include "ActiveUsersDialog.h"
#include "ActiveUserInfoDialog.h"
#include "ServerLink.h"
#include "BuenaVista.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CActiveUsersDialog dialog


CActiveUsersDialog::CActiveUsersDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CActiveUsersDialog::IDD, pParent), m_ServerLink( 0 ), m_SelectedUser( -1 )
{
	//{{AFX_DATA_INIT(CActiveUsersDialog)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CActiveUsersDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CActiveUsersDialog)
	DDX_Control(pDX, IDC_AU_LIST, m_ActiveUsersList);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CActiveUsersDialog, CDialog)
	//{{AFX_MSG_MAP(CActiveUsersDialog)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_AU_LIST, OnItemchangedAUList)
	ON_BN_CLICKED(IDCALL, OnCall)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CActiveUsersDialog message handlers
/*
void CActiveUsersDialog::OnRegister() 
{
	// TODO: Add your control notification handler code here
	CActiveUserInfoDialog dlg;
	int nResponse = dlg.DoModal();
	if (nResponse == IDOK)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with OK
		m_ServerLink->register_user( dlg.m_fname,
									 dlg.m_lname,
									 dlg.m_email );
	}
	else if (nResponse == IDCANCEL)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with Cancel
	}
}
*/
BOOL CActiveUsersDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	if( m_ActiveUsersList.InsertColumn( 0, "Name", LVCFMT_LEFT, 150 ) == -1 )
		MessageBox( "(CActiveUsersDialog) column error" );
	
	if( m_ActiveUsersList.InsertColumn( 1, "E-mail", LVCFMT_LEFT, 200, 1 ) == -1 )
		MessageBox( "(CActiveUsersDialog) column error" );

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

BOOL CActiveUsersDialog::OnCommand( WPARAM wParam, LPARAM lParam ) 
{
	// TODO: Add your specialized code here and/or call the base class
	if( ! wParam )
	{
		CServerLink::CDSMessage* msg = ( CServerLink::CDSMessage* )lParam;
		msg->execute();
		delete msg;
		return TRUE;
	}
	else
		return CDialog::OnCommand( wParam, lParam );
}

void CActiveUsersDialog::serverLink(CServerLink * sl)
{
	m_ServerLink = sl;
}

void CActiveUsersDialog::OnOK() 
{
	// TODO: Add your message handler code here and/or call default
	ShowWindow( SW_HIDE );
	GetOwner()->SetFocus();
}

void CActiveUsersDialog::OnItemchangedAUList(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;
	// TODO: Add your control notification handler code here
	if( pNMListView->uNewState & LVIS_SELECTED )
	{
		m_SelectedUser = pNMListView->iItem;
		in_addr user_addr;
		user_addr.s_addr = ntohl( pNMListView->lParam );
 		char item_str[64];
		sprintf( item_str, "IP address: %s", inet_ntoa( user_addr ) );
//		MessageBox( item_str );
	}
	*pResult = 0;
}

void CActiveUsersDialog::OnCall() 
{
	// TODO: Add your control notification handler code here
	if( ( m_SelectedUser != -1 )&&( m_ActiveUsersList.GetSelectedCount() > 0 ) )
	{
		in_addr user_addr;
		user_addr.s_addr = ntohl( m_ActiveUsersList.GetItemData( m_SelectedUser ) );
 		char item_str[64];
		sprintf( item_str, "Call: %s", inet_ntoa( user_addr ) );
		MessageBox( item_str );
		GetOwner()->PostMessage( WM_COMMAND, DS_CALL << 16, user_addr.s_addr );
	}
}
