#include "stdafx.h"
#include "DSProxy.h"
#include "DSProxyExport.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CDSProxyApp theApp;

int DSInitialize( CWnd* owner )
{
	AFX_MANAGE_STATE( AfxGetStaticModuleState() );
	theApp.m_DSDialog.SetOwner( owner );
	if( ! theApp.m_DSDialog.Create( IDD_DS_DIALOG ) )
	{
		AfxMessageBox( "Directory Server dialog creation error" );
		return -1;
	}
	theApp.m_ActiveUsersDialog->serverLink( theApp.m_ServerLink );
	theApp.m_ConferenceDialog->serverLink( theApp.m_ServerLink );
	return 0;
}

int DSConnect( Options* opt )
{
	AFX_MANAGE_STATE( AfxGetStaticModuleState() );
	theApp.m_ServerLink->user_dialog( theApp.m_ActiveUsersDialog );
	theApp.m_ServerLink->conf_dialog( theApp.m_ConferenceDialog );
	theApp.m_ServerLink->close();
	if( theApp.m_ServerLink->open( 4401, opt->server_name ) == -1 )
	{
		AfxMessageBox( "Server link open error" );
		return -1;
	}
	if( ! theApp.m_ActiveUsersDialog->m_ActiveUsersList.DeleteAllItems() )
	{
		AfxMessageBox( "Cannot clear Active Users list" );
		return -1;
	}
	if( ! theApp.m_ConferenceDialog->m_ConferenceList.DeleteAllItems() )
	{
		AfxMessageBox( "Cannot clear Conference list" );
		return -1;
	}
	if( ! theApp.m_ConferenceDialog->m_ParticipantList.DeleteAllItems() )
	{
		AfxMessageBox( "Cannot clear Participant list" );
		return -1;
	}
	theApp.m_ServerLink->request_user_synch();
	theApp.m_ServerLink->request_conf_synch();
	theApp.m_ServerLink->register_user( opt->user_name, "", opt->user_email );
	if( ! ( theApp.m_ServerThread = AfxBeginThread( CServerLink::svc_run,
												    theApp.m_ServerLink ) ) )
	{
		AfxMessageBox( "Server link activation error" );
		return -1;
	}
	return 0;
}

int DSActiveUsers( void )
{
	AFX_MANAGE_STATE( AfxGetStaticModuleState() );
	theApp.m_DSDialog.m_ConferenceDialog.ShowWindow( SW_HIDE );
	theApp.m_DSDialog.ShowWindow( SW_SHOW );
	theApp.m_DSDialog.m_Tabs.SetCurSel( 0 );
	theApp.m_DSDialog.m_ActiveUsersDialog.ShowWindow( SW_SHOW );
	theApp.m_DSDialog.SetFocus();
	return 0;
}

int DSConferences( void )
{
	AFX_MANAGE_STATE( AfxGetStaticModuleState() );
	theApp.m_DSDialog.m_ActiveUsersDialog.ShowWindow( SW_HIDE );
	theApp.m_DSDialog.ShowWindow( SW_SHOW );
	theApp.m_DSDialog.m_Tabs.SetCurSel( 1 );
	theApp.m_DSDialog.m_ConferenceDialog.ShowWindow( SW_SHOW );
	theApp.m_DSDialog.SetFocus();
	return 0;
}