#if !defined(AFX_SERVERLINK_H__6D3DD2C2_9F48_11D1_B9C4_006008134835__INCLUDED_)
#define AFX_SERVERLINK_H__6D3DD2C2_9F48_11D1_B9C4_006008134835__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

#define ACE_ERROR_RETURN( X, Y ) do { return Y; } while( 0 )
#define ACE_DEBUG( X )
#define ACE_NEW_RETURN(POINTER,CONSTRUCTOR,RET_VAL) \
   do { POINTER = new CONSTRUCTOR; \
     if (POINTER == 0) { return RET_VAL; } \
   } while (0)

#include "SAP.h"
#include "../DirServer/ProtocolInterface.h"
#include "../DirServer/MsgFlyweight.h"
#include "../DirServer/Message.h"
#include "../DirServer/MsgHeader.h"
#include "../DirServer/DirectoryProtocol.h"

typedef char ConferenceType;
typedef u_long ConferenceKey;
typedef u_long ActiveUserKey;

class CActiveUsersDialog;
class CConferenceDialog;

class CServerLink
{
public:
	typedef SAP SAP_TYPE;
	typedef MsgHeader<SAP_TYPE> CDSMsgHeader;
	typedef Message<CDSMsgHeader> CDSMessage;
	typedef MsgFlyweight<CDSMessage::MID, CDSMessage*> CDSMsgFlyweight;
	typedef ProtocolInterface<CDSMessage, CDSMsgFlyweight> CDSProtocol;

	enum { OPEN };

	CServerLink() : user_dialog_( 0 ), conf_dialog_( 0 ) {}
	int open( const unsigned short port, const char* host );
	int close() { return sap_.close(); }
	int svc();
	void user_dialog( CActiveUsersDialog* dlg ) { user_dialog_ = dlg; }
	void conf_dialog( CConferenceDialog* dlg ) { conf_dialog_ = dlg; }
	int register_user( const char* fn, const char* ln, const char* em );
	int request_user_synch();
	int request_conf_synch();
	int new_conference( ConferenceType ctype, const char* topic );
	int join_conference( ConferenceKey conf );
	int leave_conference( ConferenceKey conf );
	static UINT svc_run( LPVOID pParam );

protected:
	CDSMsgFlyweight msg_pool_;
	CDSProtocol proto_;
	SAP_TYPE sap_;
	CActiveUsersDialog* user_dialog_;
	CConferenceDialog* conf_dialog_;
};

#endif // !defined(AFX_SERVERLINK_H__6D3DD2C2_9F48_11D1_B9C4_006008134835__INCLUDED_)
