/*
 * File         : msgCUSYNCH.h
 * Author       : Pawel Roman (proman@npac.syr.edu)
 * Created      : Wed Feb 09 14:00:26 1998
 * Revision     : $Revision$
 * Updated      : $Date$
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1998
 */

#if !defined( __MSGCUSYNCH_H )
#define __MSGCUSYNCH_H

#include "ActiveUsersDialog.h"

template<class HEADER>
class msgCUSYNCH
: public Message<HEADER>
{
public:
	msgCUSYNCH( CActiveUsersDialog* dlg );
	~msgCUSYNCH();
	int recv( SAP&, HEADER& );
	int send( SAP& );
	int set( void*, size_t len );
	int execute();
	Message<HEADER>* clone() { return new msgCUSYNCH<HEADER>( ( CActiveUsersDialog* )user_ ); }
};

template<class HEADER>
inline msgCUSYNCH<HEADER>::
msgCUSYNCH( CActiveUsersDialog* dlg )
: Message<HEADER>( HEADER( DirectoryProtocol::USYNCH ) )
{
	user( ( ActiveUser* )dlg );
}

template<class HEADER>
msgCUSYNCH<HEADER>::
~msgCUSYNCH() 
{
}

template<class HEADER>
int msgCUSYNCH<HEADER>::
execute()
{
	return 0;
}

template<class HEADER>
int msgCUSYNCH<HEADER>::
recv( SAP& sap, HEADER& header_ )
{
	this->header_ = header_;
	return 0;
}

template<class HEADER>
int msgCUSYNCH<HEADER>::
send( SAP& sap )
{
	if( header_.send( sap ) == -1 )
		ACE_ERROR_RETURN(( LM_ERROR, "[!](msgCUSYNCH<HEADER>::send) header send error\n" ), -1 );

	return 0;
}

template<class HEADER>
int msgCUSYNCH<HEADER>::
set( void*, size_t )
{
	ACE_ERROR_RETURN(( LM_ERROR, "[!](msgCUSYNCH<HEADER>::set) setting error\n" ), -1 );
}

#endif
