/*
 * File         : ConferenceFactory.h
 * Author       : Pawel Roman (proman@npac.syr.edu)
 * Created      : Wed Feb 20 20:06:26 1998
 * Revision     : $Revision: 1.1 $
 * Updated      : $Date: 1998/02/28 00:57:29 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1998
 */

#if !defined( __CONFERENCEFACTORY_H )
#define __CONFERENCEFACTORY_H

#include "OpenConference.h"
#include <ace/Singleton.h>

class ConferenceFactory
{
public:
	typedef char ConferenceType;
	enum { OPEN, RESTRICTED, PROTECTED };
	Conference* create_conference( ConferenceType ctype );
};

typedef ACE_Singleton<ConferenceFactory, ACE_Null_Mutex> SDSConferenceFactory;

inline Conference* ConferenceFactory::
create_conference( ConferenceType ctype )
{
	switch( ctype )
	{
	case OPEN:
		return new OpenConference;
	default:
		return 0;
	}
}

#endif
