/*
 * File         : DirectoryProtocol.h
 * Author       : Pawel Roman (proman@npac.syr.edu)
 * Created      : Wed Jan 28 18:06:26 1998
 * Revision     : $Revision: 1.4 $
 * Updated      : $Date: 1998/02/28 00:57:33 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1998
 */

#if !defined( __DIRECTORYPROTOCOL_H )
#define __DIRECTORYPROTOCOL_H

class DirectoryProtocol
{
public:
	enum ProtoCode
	{
		INIT,     // 
		REGISTER, // User registration
		UNREG,    // User unregistration
		USYNCH,   // User synchronization request
		INVITE,   // User's invitation
		USERIP,   // User IP address
		NEWCONF,  // Create a new conference
		CSYNCH,   // Synchronize info on conferences
		DELCONF,  // Delete conference
		JOIN,	  // Joining conference request
		LEAVE,	  // Leave a conference
		ACCEPT,   // Joining conference accepted
		INFO,     // Textural Info message for user
		SHUTDOWN, // Close and clean up user's structures
		MSGMAX    // Protocol delimiter
	};
};

#endif
