/*********************************************************************
 *
 * File:         server.c
 *
 * Description:  NPAC Conferencing System API functions for server connection
 *
 * Author:       Tomasz Stachowiak, NPAC
 *
 * Date:         12-17-96
 *
 *********************************************************************/
#include <stdio.h>
#include <stdlib.h>

#include "common.h"

#define SERVER_ADDR "mirphak.npac.syr.edu"

struct sockaddr_in serv_addr;


int sendControlMessageToServer(Participant *part, WORD tag, 
			     char *data, int len)
{
  Message *msg;
  struct hostent *hostinfo;
  struct sockaddr_in addr;
  int size;
  DWORD user_len=20;

  PRINTF("Engine: send message to %s@%s \n", part->user, part->host);
  if(data != NULL)
    {
      size = sizeof(Message) + len - 1;
      msg = (Message *)malloc(size);
      if(msg == NULL)
		fprintf(stderr, "Engine: control message allocation error\n");
      memcpy(msg->data, data, len);
    }
  else
    {
      size = sizeof(Message);
      msg = (Message *)malloc(size);
      if(msg == NULL)
		fprintf(stderr, "Engine: control message allocation error\n");
      msg->data[0] = 0;
    }


  msg->local = 0;
  msg->tag = htons(tag);

  GetUserName(msg->sender.user, &user_len);
  getHostFullName(msg->sender.host, 50);
  
  strcpy(msg->receiver.user, part->user);
  strcpy(msg->receiver.host, part->host);

  hostinfo = gethostbyname(part->host);
  if(hostinfo == NULL)
    {
      fprintf(stderr, "Engine: send message unknown host %s\n", part->host);
      return 0;
    }

  addr.sin_family = AF_INET;
  addr.sin_addr.s_addr = ((struct in_addr *)hostinfo->h_addr)->s_addr;
  addr.sin_port = htons(SERVER_PORT);

  if(sendControlPacket(&addr, (char *)msg, size) < 0)
    {
      free(msg);
      return 0; 
    }

  free(msg);
  return 1;
}


void serverSendMsg(short tag, char *data, int len)
{
  Participant part;

  strcpy(part.user, "");
  strcpy(part.host, SERVER_ADDR);
  sendControlMessageToServer(&part , tag, data, len); 
}

void ncsServerAdd(void)
{
  serverSendMsg(reqServerAddUser, NULL, 0);
}

void ncsServerDel(void)
{
  serverSendMsg(reqServerDelUser, NULL, 0);
}


void ncsServerUsers()
{
  serverSendMsg(reqServerUsers, NULL, 0);
}






