// NCSvideoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "NCSvideo.h"
#include "NCSvideoDlg.h"
#include "capture.h"
#include "conference.h"
#include "display.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNCSvideoDlg dialog

CNCSvideoDlg::CNCSvideoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CNCSvideoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CNCSvideoDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CNCSvideoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CNCSvideoDlg)
	DDX_Control(pDX, IDC_STATUS, m_status);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CNCSvideoDlg, CDialog)
	//{{AFX_MSG_MAP(CNCSvideoDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_START, OnStart)
	ON_BN_CLICKED(IDC_STOP, OnStop)
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNCSvideoDlg message handlers

BOOL CNCSvideoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	CString strAboutMenu;
	strAboutMenu.LoadString(IDS_ABOUTBOX);
	if (!strAboutMenu.IsEmpty())
	{
		pSysMenu->AppendMenu(MF_SEPARATOR);
		pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
	}

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	//captureInit(this->m_hWnd);
	confInit(this);
	SetStatus("Ready");
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CNCSvideoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CNCSvideoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CNCSvideoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CNCSvideoDlg::OnStart() 
{
	//captureGrab();
}

void CNCSvideoDlg::OnStop() 
{
}

void CNCSvideoDlg::OnExit() 
{
	//captureClose();
	confClose();
	CDialog::EndDialog(0);
}

BOOL CNCSvideoDlg::OnCommand(WPARAM wParam, LPARAM lParam) 
{
	switch(HIWORD(wParam))
	{
	case CREATE_DISPLAY:
		displayOpen(LOWORD(wParam));
		break;

	case UPDATE_RATE:
		confUpdateRate();
		break;

	case BN_CLICKED:
		switch(LOWORD(wParam))
		{
		case IDC_START:
			SetStatus("Playing video...");
			confPlay();
			break;

		case IDC_STOP:
			SetStatus("Video stopped");
			confStop();
			break;

		case IDM_EXIT:
			confClose();
			CDialog::EndDialog(0);
			break;

		case IDM_START:
			SetStatus("Playing video...");
			confPlay();
			break;

		case IDM_STOP:
			SetStatus("Video stopped");
			confStop();
			break;

		case IDM_PANEL:
			confPanel();
			break;

		case IDM_STATISTICS:
			break;
		}
		break;
	}

	return TRUE; //CDialog::OnCommand(wParam, lParam);
}

void CNCSvideoDlg::OnClose() 
{
	confClose();
	CDialog::EndDialog(0);
}

void CNCSvideoDlg::SetStatus(char *text)
{
	m_status.SetSel(0, -1);
	m_status.ReplaceSel(text);
}
