import java.applet.*;
import java.awt.*;
import java.util.*;
import java.io.*;
import java.net.*;
//import filters.*;



//import interfaces.AppletBase;

//import messages.*;

//import consts.*;





public class Chat extends Frame implements ncsApplication {
	Vector lines=new Vector(10,10);
  Vector filters=new Vector(2,1);
	ChatPanel cp;
	InputPanel ip;
	FontPanel fp;
	String me;
	Date today;
	ncsAPI api;


  public void init()
  {
//    register();
  }


  public void start()
  {
	setTitle("BuenaVista Chat");
    setBackground(Color.lightGray);
	setLayout(new BorderLayout());

    add("Center",cp=new ChatPanel(this));
    cp.setBackground(Color.white);

    add("North",fp=new FontPanel(this));

    Panel p=new Panel();

    p.setLayout(new BorderLayout());

    p.add("Center",ip=new InputPanel(this));

//    p.add("South",new AudioPanel(this));

    add("South",p);

    registerFilter(new NameFilter());
    
	validate();

  /*

  	byte[] t=new byte[1];

    t[0] = CAConsts.USERNAME;

    AppEventMessage em=new AppEventMessage(Const.CONTROL,t);

    send(em);

   */

	try {
		me = InetAddress.getLocalHost().getHostName();
	} catch(Exception e) {
		me = "NoName";
		e.printStackTrace();
	}
	fp.name.setText(me);

	api = new ncsAPI(this, 6999);
    api.Attach();

  }



  public void addText(String s)

  {

    String tmp=s;

    for (int i=0;i<filters.size();i++)

      {

		Filter f=(Filter)filters.elementAt(i);

		tmp=f.processLine(tmp);

      }

	if (fp.timestamp) {
		today = new Date();
		tmp = "("+today.getHours()+":"+today.getMinutes()+") "+tmp;
	}
  
	lines.addElement(tmp);
    cp.update(lines);

  }

  public void registerFilter(Filter f)

  {

    filters.addElement(f);

//    ip.add(f.getVisual());

  }

public void changeFont(int a) {
  	cp.changeFont(a);
    cp.update(lines);
}

  
public boolean handleEvent(Event evt) {
    if(evt.id == Event.WINDOW_DESTROY) {
		api.Dettach();
		dispose();
		System.exit(0);
	}
    return super.handleEvent(evt);
}

void sendmsg(String msg)
  {
    try {
		byte[] t=new byte[msg.length()];
		msg.getBytes(0,msg.length(),t,0);
		api.SendPriorityData(-1, 1, t, msg.length());
    } catch (Exception e) {
		e.printStackTrace();
	}
  }

  public void dataCallback(int user, int tag, byte[] data, int len) {
    //System.out.println("Message from user " + user + " tag: " + tag + " Data: " + new String(data, 0));
  
	try {
		String msg=new String(data, 0, 0, data.length);
		synchronized(this) {
/*
			if (fp.timestamp) {
				today = new Date();
				msg = "("+today.getHours()+":"+today.getMinutes()+") "+msg;
			}
*/
			this.addText(msg);
		}
	} catch (Exception e) {
		e.printStackTrace();
	}

  }

  public void startingCallback() {
    //System.out.println("NCS java application started");    
  }

  public void quitCallback() {
    api.Dettach();
	dispose();
	System.exit(0);
  }

  public void addMbrCallback() {
    //System.out.println("NCS java application add member");    
  }

  public void delMbrCallback() {
    //System.out.println("NCS java application delete member");    
  }
  public static void main(String argv[]) {
    Chat chat;

    chat = new Chat();
	chat.start();
	chat.resize(500, 400);
	chat.show();
  }
}



class ChatPanel extends Panel
{
  Chat parent;
  TextCanvas tc;
  Scrollbar vs,hs;
//  int delta;
  int currLine=0;
  int currPos=0;
  int length=0;
  int size=0;
  int span;
  String longest="";



  public ChatPanel(Chat p)

    {

      parent=p;

      setLayout(new BorderLayout());

      add("Center", tc=new TextCanvas(this));

      add("East", vs=new Scrollbar(Scrollbar.VERTICAL));

      add("South",hs=new Scrollbar(Scrollbar.HORIZONTAL));

  //    delta=tc.getFontHeight();

    }

  public void update(Vector v)

  {

    size=v.size();
    String s=(String)v.lastElement();
    if (s.length()>length)
    {
		length=s.length();
		span=tc.getPixelWidth(s);
		longest=s;
    }

    scrollbarUpdate();
	tc.update(v,currLine,currPos);

  }

  public boolean handleEvent(Event evt)

  {

    if ((evt.id>600)&&(evt.id<610)&&(evt.target==vs))

      {

//	System.out.println(evt);

	currLine=vs.getValue();

//	System.out.println("VS:"+currLine);

	tc.update(parent.lines,currLine,currPos);

	return true;

      }

    if ((evt.id>600)&&(evt.id<610)&&(evt.target==hs))

      {

	currPos=hs.getValue()*span/length;

//	System.out.println("HS:"+hs.getValue());

	tc.update(parent.lines,currLine,currPos);

	return true;

      }

    return super.handleEvent(evt);

  }



  public void scrollbarUpdate()

  {

    int c=size;

    int y=tc.bounds().height;

    int x=tc.bounds().width;

    int delta=tc.getFontHeight();

    int a=(int)y/delta;

    int b=(int)c/delta;

    span=tc.getPixelWidth(longest);

    int fs=span/length;

    int cap=x/fs;

    //vs.setValues((c-a),a ,0,(c-a));
    vs.setValues(c,a ,0,c);

    hs.setValues(0,cap,0,(length-cap));

    currLine=vs.getValue();

    currPos=hs.getValue()*fs;

//   vs.setLineIncrement(vs.getLineIncrement()*100);

//    vs.setValue(c-a);

  }

  public void changeFont(int a)
  {
  	tc.setNewFont(new Font("Helvetica", Font.PLAIN, a));
  	tc.invalidate();
  	validate();
  	scrollbarUpdate();
	layout();
	repaint();
  }
}



class TextCanvas extends Canvas
{

  ChatPanel parent;

  Vector lines;

  int delta;

  int currl;

  int currp;

  public TextCanvas(ChatPanel cp)

  {

    parent=cp;

	setNewFont(new Font("Helvetica", Font.PLAIN, 12));
    //setNewFont(new Font("Courier",Font.PLAIN,20));

  }



  public void update(Vector s,int a,int b)
  {
 	lines=s;
  	currl=a;
	currp=b;
 	repaint();
  }



  public void paint(Graphics g)

  {

    if (lines==null) return;

    int c=lines.size();

    int cap=this.bounds().height;

    int l=(int)(cap/delta);

    if (c<l)

      for (int i=0;i<c;i++)

//	g.drawString((String)lines.elementAt(i),-currp,delta*(i+1));

	drawInColors(g,(String)lines.elementAt(i),-currp,delta*(i+1));

    else

      for (int i=0;i<l;i++)

//	g.drawString((String)lines.elementAt(currl+i),-currp,delta*(i+1));

	drawInColors(g,(String)lines.elementAt(currl+i),-currp,delta*(i+1));

  }



  static final void drawInColors(Graphics g,String s,int x,int y)

  {

    Color c=g.getColor();

    int currx=x;

    StringTokenizer st=new StringTokenizer(s);

    while (st.hasMoreTokens())

      {

	String t=st.nextToken();

//	System.out.println(t);

	if (t.equals("</>"))

	  {

	//    System.out.println("Setting color to default");

	    g.setColor(c);

	  }

	else

	if (t.startsWith("<") && t.endsWith(">"))

	{

	  String ns=t.substring(1,t.length()-1);

	  int a=0;

	  try

	    {

	      a=Integer.parseInt(ns);

	    }

	  catch (Exception e) {e.printStackTrace();}

	  g.setColor(new Color(a));

//	  System.out.println("Setting color to "+a);

	}

	else

	  {

//	    System.out.println("Drawing string "+t);

	    g.drawString(t+" ",currx,y);

	    currx=currx+g.getFontMetrics().stringWidth(t+" ");

	  }

      }

  }





  public void setNewFont(Font f)

  {

    Font cf=f;

    FontMetrics fm=this.getFontMetrics(cf);

    delta=fm.getHeight();

    this.setFont(cf);

  }

  public int getFontHeight()

  {

    return delta;

  }

  public int getPixelWidth(String s)

  {

    return getFontMetrics(getFont()).stringWidth(s);

  }

}





class InputPanel extends Panel
{
	Chat parent;
	TextField tf;

	public InputPanel(Chat p)
    {
      parent=p;
      add(tf=new TextField(50));
      add(new Button("Send"));
    }

	public boolean action(Event evt, Object arg)
	{

    if (arg.equals("Send")||(evt.target instanceof TextField))

      {

	String s=tf.getText();

	tf.setText("");

	String msg = parent.me + " : " + s;
	parent.sendmsg(msg);
/*
	if (parent.fp.timestamp) {
		Date today = new Date();
		msg = "("+today.getHours()+":"+today.getMinutes()+") "+msg;
	}
*/
	parent.addText(msg);

	return true;

      }

    return super.action(evt,arg);

  }

}



class FontPanel extends Panel {
	TextField tf;
	Chat parent;
	Choice sizeMenu;
	CheckboxGroup cbg;
	Checkbox yes;
	Checkbox no;
	Label name;
	int size=12;
	boolean timestamp=false;


	public FontPanel(Chat a)
	{
		parent=a;
		//add(tf=new TextField(10));
		add(new Label("User name:"));
		add(name=new Label(parent.me));
		add(new Label("Font size:"));

		sizeMenu = new Choice();
		sizeMenu.addItem("12");
		sizeMenu.addItem("14");
		sizeMenu.addItem("16");
		sizeMenu.addItem("18");
		sizeMenu.addItem("20");
		sizeMenu.addItem("22");
		sizeMenu.addItem("24");
		sizeMenu.addItem("26");
		sizeMenu.addItem("28");
		sizeMenu.addItem("30");
		sizeMenu.addItem("32");
		sizeMenu.addItem("34");
		sizeMenu.addItem("42");
		//sizeMenu.select("26");

		sizeMenu.select("12");

		add(sizeMenu);

		cbg = new CheckboxGroup();
		add(new Label("Timestamp:"));
	    add(yes = new  Checkbox("Yes",cbg,timestamp));
		add(no = new  Checkbox("No",cbg,(!timestamp)));
	}

  public boolean action(Event evt, Object arg)

  {

    if (evt.target==sizeMenu)

      {

				String s=sizeMenu.getSelectedItem();

//				System.out.println(s);

//		tf.setText("");

				int a=size;

				try

				{

					a=Integer.parseInt(s);

				}

				catch (Exception e) {e.printStackTrace();}

				if (a!=size)

				{

					parent.changeFont(a);

					size=a;

				}

				return true;

      }

    if (evt.target==yes)
    {
		timestamp = true;
	}
	if (evt.target==no)
    {
		timestamp = false;
	}

    return super.action(evt,arg);

  }

}



class AudioButton extends Button {

    AudioClip ac;

    public AudioButton(Frame a,String s,String title) {

        super(title);

        //ac=a.getAudioClip(a.getCodeBase(),s);

    }

    public boolean action(Event e,Object a) {

        ac.play();

        return true;

    }



}



class AudioPanel extends Panel {

    public AudioPanel(Frame a) {

        add(new AudioButton(a,"sounds/represd.au","repressed"));

        add(new AudioButton(a,"sounds/myob2.au","business"));

//        add(new AudioButton(a,"sounds/thank.au","thank you"));

        add(new AudioButton(a,"sounds/albatros.au","albatros"));

        add(new AudioButton(a,"sounds/Volk.au","veibvolk"));

        add(new AudioButton(a,"sounds/bye.au","bye bye"));

    }

}