#include <MMSYSTEM.H>
#include "Conference.h"

#define PORTION_SIZE 1600
#define PORTION_SAMPLES 800

typedef struct _audioOutPort
{
	HWAVEOUT handle;				// handle for out port
	HANDLE hEvent;					// event for synchronize writting(not used)
	WAVEHDR header[2];				// wave data header
	int headerNo;					// number of current header
	int first;						// writing state
	int active;
	HANDLE hThread;
	DWORD dwWriteThreadId;
	short buffer[PORTION_SAMPLES];
	HANDLE hBufEvent;
} AudioOutPort;


int audioInit(Conference *conf);
void audioClose(void);
    
/////////////////////////////////////////////////////////////////////////
// audio reading functions
int audioReadInit(void);
DWORD audioReadThread(LPDWORD lpdwParam);
void audioReadClose(void);
void audioReadChunk(void);
void audioReadHandler(void *buffer);
void audioReadStart(void);
void audioReadStop(void);

/////////////////////////////////////////////////////////////////////////
// audio writing functions
int audioWriteInit(void);
void audioWriteClose(void);
void audioWriteVolume(UINT vol);
void audioWriteChunk(void);
short audioWriteAddToBuf(void *buffer);
DWORD audioWriteThread(LPDWORD lpdwParam);

