#include <stdio.h>
#include <winsock.h>

#include "event.h"
#include "recorder.h"



int NCSrecorder::init()
{
  char *ncspath;
  char path[100];

  ncspath = getenv("NCS_PATH");
  strcpy(path, ncspath);
  strcat(path, "\\recorder.data");
  first = 1;
  
  if((fd = fopen(path, "wb")) < 0)
    {
      fprintf(stderr, "Recorder: file open error\n");
      exit(-1);
    }

  if((sock = socket(AF_INET, SOCK_DGRAM, 0)) < 0)
    {
      fprintf(stderr, "Recorder: cannot open socket\n");
      return -1;
    }
  
  addr.sin_family = AF_INET;
  addr.sin_port = htons(RECORDER_PORT);
  addr.sin_addr.s_addr = htonl(INADDR_ANY);
  
  if((bind(sock, (struct sockaddr *)&addr, sizeof(struct sockaddr_in))) < 0)
    {
      fprintf(stderr, "Recorder: bind error\n");
      return -1;
    }

  return 1;
}

void NCSrecorder::quit()
{
  closesocket(sock);
  fclose(fd);
  exit(0);
}


void NCSrecorder::run()
{
  fd_set set;
  struct timeval timeout;
  
  while(1)
    {
      timeout.tv_sec = 0;
      timeout.tv_usec = 100000;
      FD_ZERO(&set);
      FD_SET(sock, &set);
      if(select(sock+1, &set, 0, 0, &timeout) > 0)
	{
	  if(FD_ISSET(sock, &set))
	    {
	      event.receive(sock);
	      event.save(fd);
	    }
	}
    }
  quit();
}


NCSrecorder recorder;

void quit()
{
  recorder.quit();
  exit(0);
}

void main(void)
{
  WSADATA wsaData;	

  if(WSAStartup(257, &wsaData) != 0)
	  fprintf(stderr, "Engine: can't startup winsock\n");

  recorder.init();
  recorder.run();
}



