//////////////////////////////////////////////////////////////////////////
//
// File					: rgb2yuv.cpp
//
// Description			: Converts RGB 16 to YUV 411
//
///////////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include "rgb2yuv.h"

char getR(WORD rgb)
{
	char result;

	result = (char)(rgb & 0x1F);
	return result;
}

char getG(WORD rgb)
{
	char result;

	result = (char)((rgb >> 5) & 0x1F);
	return result;
}

char getB(WORD rgb)
{
	char result;

	result = (char)((rgb >> 10) & 0x1F);
	return result;
}

void rgb2yuv(WORD *input, char *output, int width, int height)
{
	int i, j;
	char *y = output;
	char *u = output+(width*height);
	char *v = output+(width*height*5/4);

	for(i=0; i<height; i++)
	{
		for(j=0; j<width; j++)
		{
			y[i*width + j] = .299*(float)getR(input[i*width + j]) 
							+.587*(float)getG(input[i*width + j])
							+.114*(float)getG(input[i*width + j]);
			if(((i%2) == 1) && ((j%2) == 1))
			{
				u[((i/2)*(width/2)) + (j/2)] = (float)((getR(input[i*width + j]) - y[i*width + j])
											+  (getR(input[i*width + j-1]) - y[i*width + j-1])
											+  (getR(input[i*(width-1) + j-1]) - y[i*(width-1) + j-1])
											+  (getR(input[i*(width-1) + j]) - y[i*(width-1) + j]))/(float)4;

				v[((i/2)*(width/2)) + (j/2)] = (float)((getB(input[i*width + j]) - y[i*width + j])
											+  (getB(input[i*width + j-1]) - y[i*width + j-1])
											+  (getB(input[i*(width-1) + j-1]) - y[i*(width-1) + j-1])
											+  (getB(input[i*(width-1) + j]) - y[i*(width-1) + j]))/(float)4;
			}
		}
	}
}

