#ifndef _BVA_H
#define _BVA_H

#include <windows.h>         
#include <winbase.h>
#include <MMSYSTEM.H>

#define CURRENTPOS 21
#define DEFAULT_SIZE 1600
#define MAX_STREAMS 2
#define BUFFERS_NO 2
#define DELAY 3200

class BVAbuffer
{
private:
	int first;
	int size;
	int pos;
	int relpos;
	char *buffer;
	HANDLE event;

public:
	int ready();
	void reset();
	BVAbuffer(int len);
	~BVAbuffer();
	int lock(int len, int pos, char **ptr1, int *size1, char **ptr2, int *size2, int flag);
	int get(int len, char **ptr1, int *size1, char **ptr2, int *size2);
	int unlock();
	int play(char *buf, int len);
};

class BVA
{
	static DWORD playThread(LPDWORD lpdwParam);

private:
	UINT tres;

public:
	int size;
	int streams;					// number of streams
	HWAVEOUT handle;				// handle for out port
	HANDLE hEvent;					// event for synchronize writting(not used)
	WAVEHDR header[BUFFERS_NO];				// wave data header
	int headerNo;					// number of current header
	int first;						// writing state
	int active;
	HANDLE hThread; 
	DWORD dwThreadId;
	short *primary;
	BVAbuffer *bvabuffer[MAX_STREAMS];
	WAVEFORMATEX *format;
	int on;
	int all, late;
	int early, toolate;

	
	
	MMRESULT TimerID;
	int verylate;
	void reset();
	BVA();
	~BVA();
	int init();
	void close();
	int play(char *buffer);
	int start();
	int stop();
	BVAbuffer *createBuffer(int len);
	int deleteBuffer(BVAbuffer *buf);
};

void CALLBACK Timer(UINT wTimerID, UINT msg, 
    DWORD dwUser, DWORD dw1, DWORD dw2);
  
#endif
